
#ifndef LIRICORE_EXPORT_H
#define LIRICORE_EXPORT_H

#ifdef LIRICORE_STATIC_DEFINE
#  define LIRICORE_EXPORT
#  define LIRICORE_NO_EXPORT
#else
#  ifndef LIRICORE_EXPORT
#    ifdef LIRI_BUILD_CORE_LIB
        /* We are building this library */
#      define LIRICORE_EXPORT __attribute__((visibility("default")))
#    else
        /* We are using this library */
#      define LIRICORE_EXPORT __attribute__((visibility("default")))
#    endif
#  endif

#  ifndef LIRICORE_NO_EXPORT
#    define LIRICORE_NO_EXPORT __attribute__((visibility("hidden")))
#  endif
#endif

#ifndef LIRICORE_DECL_DEPRECATED
#  define LIRICORE_DECL_DEPRECATED __attribute__ ((__deprecated__))
#endif

#ifndef LIRICORE_DECL_DEPRECATED_EXPORT
#  define LIRICORE_DECL_DEPRECATED_EXPORT LIRICORE_EXPORT LIRICORE_DECL_DEPRECATED
#endif

#ifndef LIRICORE_DECL_DEPRECATED_NO_EXPORT
#  define LIRICORE_DECL_DEPRECATED_NO_EXPORT LIRICORE_NO_EXPORT LIRICORE_DECL_DEPRECATED
#endif

/* NOLINTNEXTLINE(readability-avoid-unconditional-preprocessor-if) */
#if 0 /* DEFINE_NO_DEPRECATED */
#  ifndef LIRICORE_NO_DEPRECATED
#    define LIRICORE_NO_DEPRECATED
#  endif
#endif

#define LIRICORE_DECL_DEPRECATED_TEXT(text) __attribute__ ((__deprecated__(text)))

#if defined(LIRICORE_NO_DEPRECATED)
#  undef LIRICORE_DEPRECATED
#  define LIRICORE_DEPRECATED_EXPORT LIRICORE_EXPORT
#  define LIRICORE_DEPRECATED_NO_EXPORT LIRICORE_NO_EXPORT
#elif defined(LIRICORE_NO_DEPRECATED_WARNINGS)
#  define LIRICORE_DEPRECATED
#  define LIRICORE_DEPRECATED_EXPORT LIRICORE_EXPORT
#  define LIRICORE_DEPRECATED_NO_EXPORT LIRICORE_NO_EXPORT
#else
#  define LIRICORE_DEPRECATED LIRICORE_DECL_DEPRECATED
#  define LIRICORE_DEPRECATED_EXPORT LIRICORE_DECL_DEPRECATED_EXPORT
#  define LIRICORE_DEPRECATED_NO_EXPORT LIRICORE_DECL_DEPRECATED_NO_EXPORT
#endif

/* No deprecated API had been removed from build */
#define LIRICORE_EXCLUDE_DEPRECATED_BEFORE_AND_AT 0

#define LIRICORE_BUILD_DEPRECATED_SINCE(major, minor) 1

#ifdef LIRICORE_NO_DEPRECATED
#  define LIRICORE_DISABLE_DEPRECATED_BEFORE_AND_AT 0x900
#endif
#ifdef LIRICORE_NO_DEPRECATED_WARNINGS
#  define LIRICORE_DEPRECATED_WARNINGS_SINCE 0
#endif

#ifndef LIRICORE_DEPRECATED_WARNINGS_SINCE
#  ifdef LIRICORE_DISABLE_DEPRECATED_BEFORE_AND_AT
#    define LIRICORE_DEPRECATED_WARNINGS_SINCE LIRICORE_DISABLE_DEPRECATED_BEFORE_AND_AT
#  else
#    define LIRICORE_DEPRECATED_WARNINGS_SINCE 0x900
#  endif
#endif

#ifndef LIRICORE_DISABLE_DEPRECATED_BEFORE_AND_AT
#  define LIRICORE_DISABLE_DEPRECATED_BEFORE_AND_AT 0x0
#endif

#ifdef LIRICORE_DEPRECATED
#  define LIRICORE_ENABLE_DEPRECATED_SINCE(major, minor) (((major<<16)|(minor<<8)) > LIRICORE_DISABLE_DEPRECATED_BEFORE_AND_AT)
#else
#  define LIRICORE_ENABLE_DEPRECATED_SINCE(major, minor) 0
#endif

#endif /* LIRICORE_EXPORT_H */
