
#ifndef LIRIMODELS_EXPORT_H
#define LIRIMODELS_EXPORT_H

#ifdef LIRIMODELS_STATIC_DEFINE
#  define LIRIMODELS_EXPORT
#  define LIRIMODELS_NO_EXPORT
#else
#  ifndef LIRIMODELS_EXPORT
#    ifdef LIRI_BUILD_MODELS_LIB
        /* We are building this library */
#      define LIRIMODELS_EXPORT __attribute__((visibility("default")))
#    else
        /* We are using this library */
#      define LIRIMODELS_EXPORT __attribute__((visibility("default")))
#    endif
#  endif

#  ifndef LIRIMODELS_NO_EXPORT
#    define LIRIMODELS_NO_EXPORT __attribute__((visibility("hidden")))
#  endif
#endif

#ifndef LIRIMODELS_DECL_DEPRECATED
#  define LIRIMODELS_DECL_DEPRECATED __attribute__ ((__deprecated__))
#endif

#ifndef LIRIMODELS_DECL_DEPRECATED_EXPORT
#  define LIRIMODELS_DECL_DEPRECATED_EXPORT LIRIMODELS_EXPORT LIRIMODELS_DECL_DEPRECATED
#endif

#ifndef LIRIMODELS_DECL_DEPRECATED_NO_EXPORT
#  define LIRIMODELS_DECL_DEPRECATED_NO_EXPORT LIRIMODELS_NO_EXPORT LIRIMODELS_DECL_DEPRECATED
#endif

/* NOLINTNEXTLINE(readability-avoid-unconditional-preprocessor-if) */
#if 0 /* DEFINE_NO_DEPRECATED */
#  ifndef LIRIMODELS_NO_DEPRECATED
#    define LIRIMODELS_NO_DEPRECATED
#  endif
#endif

#define LIRIMODELS_DECL_DEPRECATED_TEXT(text) __attribute__ ((__deprecated__(text)))

#if defined(LIRIMODELS_NO_DEPRECATED)
#  undef LIRIMODELS_DEPRECATED
#  define LIRIMODELS_DEPRECATED_EXPORT LIRIMODELS_EXPORT
#  define LIRIMODELS_DEPRECATED_NO_EXPORT LIRIMODELS_NO_EXPORT
#elif defined(LIRIMODELS_NO_DEPRECATED_WARNINGS)
#  define LIRIMODELS_DEPRECATED
#  define LIRIMODELS_DEPRECATED_EXPORT LIRIMODELS_EXPORT
#  define LIRIMODELS_DEPRECATED_NO_EXPORT LIRIMODELS_NO_EXPORT
#else
#  define LIRIMODELS_DEPRECATED LIRIMODELS_DECL_DEPRECATED
#  define LIRIMODELS_DEPRECATED_EXPORT LIRIMODELS_DECL_DEPRECATED_EXPORT
#  define LIRIMODELS_DEPRECATED_NO_EXPORT LIRIMODELS_DECL_DEPRECATED_NO_EXPORT
#endif

/* No deprecated API had been removed from build */
#define LIRIMODELS_EXCLUDE_DEPRECATED_BEFORE_AND_AT 0

#define LIRIMODELS_BUILD_DEPRECATED_SINCE(major, minor) 1

#ifdef LIRIMODELS_NO_DEPRECATED
#  define LIRIMODELS_DISABLE_DEPRECATED_BEFORE_AND_AT 0x900
#endif
#ifdef LIRIMODELS_NO_DEPRECATED_WARNINGS
#  define LIRIMODELS_DEPRECATED_WARNINGS_SINCE 0
#endif

#ifndef LIRIMODELS_DEPRECATED_WARNINGS_SINCE
#  ifdef LIRIMODELS_DISABLE_DEPRECATED_BEFORE_AND_AT
#    define LIRIMODELS_DEPRECATED_WARNINGS_SINCE LIRIMODELS_DISABLE_DEPRECATED_BEFORE_AND_AT
#  else
#    define LIRIMODELS_DEPRECATED_WARNINGS_SINCE 0x900
#  endif
#endif

#ifndef LIRIMODELS_DISABLE_DEPRECATED_BEFORE_AND_AT
#  define LIRIMODELS_DISABLE_DEPRECATED_BEFORE_AND_AT 0x0
#endif

#ifdef LIRIMODELS_DEPRECATED
#  define LIRIMODELS_ENABLE_DEPRECATED_SINCE(major, minor) (((major<<16)|(minor<<8)) > LIRIMODELS_DISABLE_DEPRECATED_BEFORE_AND_AT)
#else
#  define LIRIMODELS_ENABLE_DEPRECATED_SINCE(major, minor) 0
#endif

#endif /* LIRIMODELS_EXPORT_H */
