
#ifndef LIRIXDG_EXPORT_H
#define LIRIXDG_EXPORT_H

#ifdef LIRIXDG_STATIC_DEFINE
#  define LIRIXDG_EXPORT
#  define LIRIXDG_NO_EXPORT
#else
#  ifndef LIRIXDG_EXPORT
#    ifdef LIRI_BUILD_XDG_LIB
        /* We are building this library */
#      define LIRIXDG_EXPORT __attribute__((visibility("default")))
#    else
        /* We are using this library */
#      define LIRIXDG_EXPORT __attribute__((visibility("default")))
#    endif
#  endif

#  ifndef LIRIXDG_NO_EXPORT
#    define LIRIXDG_NO_EXPORT __attribute__((visibility("hidden")))
#  endif
#endif

#ifndef LIRIXDG_DECL_DEPRECATED
#  define LIRIXDG_DECL_DEPRECATED __attribute__ ((__deprecated__))
#endif

#ifndef LIRIXDG_DECL_DEPRECATED_EXPORT
#  define LIRIXDG_DECL_DEPRECATED_EXPORT LIRIXDG_EXPORT LIRIXDG_DECL_DEPRECATED
#endif

#ifndef LIRIXDG_DECL_DEPRECATED_NO_EXPORT
#  define LIRIXDG_DECL_DEPRECATED_NO_EXPORT LIRIXDG_NO_EXPORT LIRIXDG_DECL_DEPRECATED
#endif

/* NOLINTNEXTLINE(readability-avoid-unconditional-preprocessor-if) */
#if 0 /* DEFINE_NO_DEPRECATED */
#  ifndef LIRIXDG_NO_DEPRECATED
#    define LIRIXDG_NO_DEPRECATED
#  endif
#endif

#define LIRIXDG_DECL_DEPRECATED_TEXT(text) __attribute__ ((__deprecated__(text)))

#if defined(LIRIXDG_NO_DEPRECATED)
#  undef LIRIXDG_DEPRECATED
#  define LIRIXDG_DEPRECATED_EXPORT LIRIXDG_EXPORT
#  define LIRIXDG_DEPRECATED_NO_EXPORT LIRIXDG_NO_EXPORT
#elif defined(LIRIXDG_NO_DEPRECATED_WARNINGS)
#  define LIRIXDG_DEPRECATED
#  define LIRIXDG_DEPRECATED_EXPORT LIRIXDG_EXPORT
#  define LIRIXDG_DEPRECATED_NO_EXPORT LIRIXDG_NO_EXPORT
#else
#  define LIRIXDG_DEPRECATED LIRIXDG_DECL_DEPRECATED
#  define LIRIXDG_DEPRECATED_EXPORT LIRIXDG_DECL_DEPRECATED_EXPORT
#  define LIRIXDG_DEPRECATED_NO_EXPORT LIRIXDG_DECL_DEPRECATED_NO_EXPORT
#endif

/* No deprecated API had been removed from build */
#define LIRIXDG_EXCLUDE_DEPRECATED_BEFORE_AND_AT 0

#define LIRIXDG_BUILD_DEPRECATED_SINCE(major, minor) 1

#ifdef LIRIXDG_NO_DEPRECATED
#  define LIRIXDG_DISABLE_DEPRECATED_BEFORE_AND_AT 0x900
#endif
#ifdef LIRIXDG_NO_DEPRECATED_WARNINGS
#  define LIRIXDG_DEPRECATED_WARNINGS_SINCE 0
#endif

#ifndef LIRIXDG_DEPRECATED_WARNINGS_SINCE
#  ifdef LIRIXDG_DISABLE_DEPRECATED_BEFORE_AND_AT
#    define LIRIXDG_DEPRECATED_WARNINGS_SINCE LIRIXDG_DISABLE_DEPRECATED_BEFORE_AND_AT
#  else
#    define LIRIXDG_DEPRECATED_WARNINGS_SINCE 0x900
#  endif
#endif

#ifndef LIRIXDG_DISABLE_DEPRECATED_BEFORE_AND_AT
#  define LIRIXDG_DISABLE_DEPRECATED_BEFORE_AND_AT 0x0
#endif

#ifdef LIRIXDG_DEPRECATED
#  define LIRIXDG_ENABLE_DEPRECATED_SINCE(major, minor) (((major<<16)|(minor<<8)) > LIRIXDG_DISABLE_DEPRECATED_BEFORE_AND_AT)
#else
#  define LIRIXDG_ENABLE_DEPRECATED_SINCE(major, minor) 0
#endif

#endif /* LIRIXDG_EXPORT_H */
